/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jetspeed.security.spi;

import java.util.List;

import org.apache.jetspeed.security.PasswordCredential;
import org.apache.jetspeed.security.User;

/**
 * @version $Id: UserPasswordCredentialAccessManager.java 732386 2009-01-07 16:33:26Z ddam $
 *
 */
public interface UserPasswordCredentialAccessManager
{
    /**
     * Get the PasswordCredential for a User for authentication purposes.
     * <p>
     * This method is intended to be used by an AuthenticationProvider.
     * </p>
     * @param userName
     * @return
     */
    PasswordCredential getPasswordCredential(String userName);
    void loadPasswordCredentialUser(PasswordCredential credential);
    List<PasswordCredential> getHistoricPasswordCredentials(User user);


    PasswordCredential getPasswordCredential(String userName, Long securityDomain);
    List<PasswordCredential> getHistoricPasswordCredentials(User user, Long securityDomain);

}
