/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jetspeed.container;

import org.apache.jetspeed.om.page.ContentFragment;
import org.apache.jetspeed.om.portlet.PortletDefinition;

/**
 * @version $Id: PortletEntity.java 881862 2009-11-18 18:24:48Z rwatler $
 * @obsolete Pluto no longer provides a PortletEntity interface and Jetspeed no longer uses it. 
 */
public interface PortletEntity // extends org.apache.pluto.container.PortletEntity
{
    Long getOid();
    String getId();
    void setId(String id);
    
    void setPortletWindow(PortletWindow window);

    PortletDefinition getPortletDefinition();
    void setPortletDefinition(PortletDefinition portletDefinition);

    String getPortletUniqueName();

    void setFragment(ContentFragment fragment);
    ContentFragment getFragment();    
}
