/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jetspeed.container.state;

import org.apache.jetspeed.exception.JetspeedRuntimeException;

/**
 * <p>
 * FailedToCreatePortalUrl
 * </p>
 * <p>
 *  Thrown if an attempt to create a Portal URL met with an unexpected
 *  failure. 
 * </p>
 * @author <a href="mailto:weaver@apache.org">Scott T. Weaver</a>
 * @version $Id: FailedToCreatePortalUrlException.java 516448 2007-03-09 16:25:47Z ate $
 *
 */
public class FailedToCreatePortalUrlException extends JetspeedRuntimeException
{

    /**
     * 
     */
    public FailedToCreatePortalUrlException()
    {
        super();
        // TODO Auto-generated constructor stub
    }

    /**
     * @param arg0
     */
    public FailedToCreatePortalUrlException( String arg0 )
    {
        super(arg0);
        // TODO Auto-generated constructor stub
    }

    /**
     * @param arg0
     */
    public FailedToCreatePortalUrlException( Throwable arg0 )
    {
        super(arg0);
        // TODO Auto-generated constructor stub
    }

    /**
     * @param arg0
     * @param arg1
     */
    public FailedToCreatePortalUrlException( String arg0, Throwable arg1 )
    {
        super(arg0, arg1);
        // TODO Auto-generated constructor stub
    }

}
